#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/param.h>

#define SWAP(a,b) tempr=(a) ; (a)=(b) ; (b)=tempr


char appdirname[1024];
char outdirname[1024];
char cddirname[1024];
char ripfilename[1024];
char trackfilename[1024];
char tempfilename[1024];
char tempdirname[1024];
char specinputname[1024];
char specfilename[1024];
char outfilename[1024];
char leafname[512];
char outname[512];
unsigned char vlabeltext[256];

char resdirname[1024];

char ripline[1024];
char reply[256];
char command[1024];

char drive[64];

int ok,line,istop,i,count,tn,numberoftracks;
int tmin,tsec,emin,esec,chunks_done;

int wavstarts[99];
int nstarts, newstart;

int mins[99],startframe[99];
double secs[99];
int minslong[99];
double secslong[99];
int tracklength_blocks[99];
int tail[99];

char yesno[5];


short dbuffer[5300000];

int bits_per_sample,sample_rate,blocksize,chunksize;
int left_hist[65537], right_hist[65537];
int izero,nsamples_per_channel,itop,dco_left,dco_right;

double xleft[4096],xright[4096], weight[4096];
double x[8192];  /* double size for imag zeros */
double pout_left[2048], pout_right[2048];

double pi,pi2;
int i,il,ir,id,ispec0;
int n,nn,npoints,nhalf;
int discreaderror;

double bscale,hscale;

/* FILE* ripfile; */
FILE* tracklistfile;
FILE* tfile;
FILE* outfile;
FILE* infile;
FILE* specfile;
FILE* vin;
FILE* vout;

void read_settings_file(void);
int get_command(void);
void parse_trackinfo(void);
void make_timefiles(void);
void remove_tempfile(void);
void process_chunk(void);
void process_results(void);
void report_histograms(void);

void do_spectra(void);
void generate_apodise_weights(void);
void loadnorm(void);
void apodise(void);
void load_fft_array(double*);
void fft(void);
void bit_rev(void);
void save_ampspectrum(double*);
void save_outputspectra(void);
void output_veusz(void);
void veusz_label(char*,char*,double,double);



int main(int argc,char* argv[])
{
  
  
  printf("  CD_HealthCheck Ver 0.60  31st May 2015\n");
  printf("  ======================================\n\n");
  printf("\n  Lets the user check an Audio CD track\n");
  
  
  blocksize=44100*60*2; bits_per_sample=16; sample_rate=44100;
  itop=65536; izero=itop/2; nsamples_per_channel=0;
  dco_left=0; dco_right=0;
  pi=3.1415927;
  pi2=3.1415927*2.0;
  n=4096; nn=2*n; npoints=n; nhalf=n/2;
  discreaderror=0;
  
  
  sprintf(appdirname,"%s",argv[0]);
  ok=(int)strrchr(appdirname,'/')-(int)appdirname;
  appdirname[ok]=(char)0;
  printf("Application directory = %s\n",appdirname);
  read_settings_file();
  
  printf("Enter sub-directory name for this CD's results =>  ");
  scanf("%s",cddirname);
  
  sprintf(command,"cdparanoia -d %s -Q 2> %s/tracks.txt",drive,tempdirname);
  
  printf("Command is %s\n",command);
  
  system(command);
  
  parse_trackinfo();
  
  printf("Choose number of track to examine => ");
  
  
  
  scanf("%d",&tn);
  
  sprintf(outdirname,"%s/%s_track%02d",resdirname,cddirname,tn);
  
  sprintf(leafname,"%s track %2d",cddirname,tn);
  
  printf("Output to directory: %s\n",outdirname);
  
  
  
  ok=1;
  
  if(tn>numberoftracks)
  {
    ok=0;
    printf("  ***  Track number too large!  ***\n");
  }
  
  if(tn<1)
  {
    ok=0;
    printf("  ***  Track number less than 1 ! ***\n");
  }
  
  if (ok==1)
  {
    printf("Examining track %d which has %d full one min blocks\n",tn,tracklength_blocks[tn]);
    
    sprintf(command,"mkdir -p %s",outdirname);
    printf("Making output directory with: %s\n",command);
    system(command);
    
    tmin=0; tsec=0; emin=1; esec=0; chunks_done=0;
    
    if(tracklength_blocks[tn]>0)
    {
    do
    {
      sprintf(command,"cdparanoia --output-raw-little-endian -q -d %s  %d[%d:%02d]-%d[%d:%02d] %s",drive,tn,tmin,tsec,tn,emin,esec,tempfilename);
    
      /* printf("cdparanoia command:\n %s\n",command); */
      printf("Reading track chunk from %d to %d mins\n",tmin,emin);
      system(command);
      
      tmin++; emin++;
      
      tfile=fopen(tempfilename,"rd");
      chunksize=fread(dbuffer,sizeof(short),blocksize,tfile);
      fclose(tfile);
      
      printf("Chunk read from tempfile = %d shorts\n",chunksize);
      
      process_chunk();
      
      remove_tempfile();
      
      chunks_done++;
       
    } while (chunks_done<tracklength_blocks[tn]);
    }
    
    
    
    sprintf(command,"cdparanoia --output-raw-little-endian -q -d %s  %d[%d:%02d] %s",drive,tn,tmin,tsec,tempfilename);
    printf("Reading track chunk from %d min to end\n",tmin);
    
    /* printf("cdparanoia tail command:\n %s\n",command); */
    system(command);
    tfile=fopen(tempfilename,"rd");
    chunksize=fread(dbuffer,sizeof(short),blocksize,tfile);
    fclose(tfile);
    printf("shorts read from tail = %d\n",chunksize);
    
    if(chunksize>0)
    {
     process_chunk();
    }
    remove_tempfile();
    
    process_results();
    report_histograms();
    
    do_spectra();
    
    output_veusz();
  
  }
  
  
  printf("\n  Done!\n");
  
}


void output_veusz(void)
{
  char vinname[1024];
  char voutname[1024];
  char vchar;
  
  int vcheck, vcount;
  
  
  sprintf(vinname,"%s/spectrum_style.vsz",appdirname);
  /* printf("Style from %s\n",vinname); */
  sprintf(voutname,"%s/load_intervalspectrum.vsz",outdirname);
  /* printf("Interval loader file %s\n",voutname); */
  vin=fopen(vinname,"rt");  vout=fopen(voutname,"wt");
  vcount=0;
  do
  {
    vcheck=(long)fscanf(vin,"%c",&vchar); 
    if (vcheck==1) fprintf(vout,"%c",vchar);
    vcount++;
    if(vcount>10000) vcheck=0;
  } while (vcheck==1);
  /* printf(" got %d",vcount); */
  fclose(vin);
  sprintf(vlabeltext,"Results for:   %s",leafname);
  veusz_label(vlabeltext,"label1",0.14,0.91);
  sprintf(vlabeltext,"sample rate = %d   bits/sample = %d",sample_rate,bits_per_sample);
  veusz_label(vlabeltext,"label2",0.14,0.86);
  fclose(vout);
  
  sprintf(vinname,"%s/normstats_style.vsz",appdirname);
  sprintf(voutname,"%s/load_normstats.vsz",outdirname);
  /* printf("From %s\n to %s\n",vinname,voutname); */
  vin=fopen(vinname,"rt");  vout=fopen(voutname,"wt");
  vcount=0;
  do
  {
    vcheck=(long)fscanf(vin,"%c",&vchar); 
    if (vcheck==1) fprintf(vout,"%c",vchar);
    vcount++;
    if(vcount>10000) vcheck=0;
  } while (vcheck==1);
  
  fclose(vin);
  sprintf(vlabeltext,"Results for:   %s",leafname);
  veusz_label(vlabeltext,"label1",0.14,0.91);
  sprintf(vlabeltext,"sample rate = %d   bits/sample = %d",sample_rate,bits_per_sample);
  veusz_label(vlabeltext,"label2",0.14,0.86);
  fclose(vout);
  
  
  sprintf(vinname,"%s/32blocked_style.vsz",appdirname);
  sprintf(voutname,"%s/load_32blocked_samplestats.vsz",outdirname);
  /* printf("From %s\n to %s\n",vinname,voutname); */
  vin=fopen(vinname,"rt");  vout=fopen(voutname,"wt");
  vcount=0;
  do
  {
    vcheck=(long)fscanf(vin,"%c",&vchar); 
    if (vcheck==1) fprintf(vout,"%c",vchar);
    vcount++;
    if(vcount>10000) vcheck=0;
  } while (vcheck==1);
  
  fclose(vin);
  sprintf(vlabeltext,"Results for:   %s",leafname);
  veusz_label(vlabeltext,"label1",0.14,0.91);
  sprintf(vlabeltext,"sample rate = %d   bits/sample = %d",sample_rate,bits_per_sample);
  veusz_label(vlabeltext,"label2",0.14,0.86);
  fclose(vout);
  
  
}


void veusz_label(char* label_text,char* label_name,double xlpos,double ylpos)
{
   fprintf(vout,"To('..')\n");
   fprintf(vout,"Add('label', name='%s',autoadd=False)\n",label_name);
   fprintf(vout,"To('%s')\n",label_name);
   fprintf(vout,"Set('label', u'%s')\n",label_text);
   fprintf(vout,"Set('xPos', [%7.4lf])\n",xlpos);
   fprintf(vout,"Set('yPos', [%7.4lf])\n",ylpos);

}



void do_spectra(void)
{
  
  generate_apodise_weights();
  loadnorm();
  apodise();
  load_fft_array(xleft);
  fft();
  save_ampspectrum(pout_left);
  load_fft_array(xright);
  fft();
  save_ampspectrum(pout_right);
  save_outputspectra();
}

void bit_rev(void)
{
  int ibr,jbr,mbr;
  double tr,ti;
  jbr=1;
  ibr=1;
  do
  {
    if ( jbr > ibr )
    {
      tr=x[jbr];
      ti=x[jbr+1];
      x[jbr]=x[ibr];
      x[jbr+1]=x[ibr+1];
      x[ibr]=tr;
      x[ibr+1]=ti;
    }
    mbr=nn/2;
    while ( mbr >= 2 && jbr > mbr )
    {
      jbr-=mbr;
      mbr=mbr/2;
    }
    jbr=jbr+mbr;   
    ibr+=2;
  } while ( ibr < nn );
}



void fft(void)
{
  int mmax,istep,m,i,j;
  int ibig,ismall,jbig,jsmall;
  double theta,wpi,wpr;
  double wi,wr,tr,ti,wtemp;
  
  ibig=-99;  jbig=-99;
  ismall=99; jsmall=99;

  mmax=2;
  theta=2.0*pi/mmax;
  
  bit_rev();
  
  while ( nn > mmax )
  {
   istep=2*mmax;
   theta=2.0*pi/mmax;
   wpr=-2.0*sin(0.5*theta)*sin(0.5*theta);
   wpi=sin(theta);
   wr=1.0;
   wi=0.0;
   m=1;
   do
   {
     i=m;
     do
     {
       j=i+mmax;
       
       if(i>ibig)
       {
         ibig=i;
       }
       if(i<ismall)
       {
         ismall=i;
       }
       if (j>jbig)
       {
         jbig=j;
       }
       if (j<jsmall)
       {
         jsmall=j;
       }
       tr=wr*x[j]-wi*x[j+1];
       ti=wr*x[j+1]+wi*x[j];
       x[j]=x[i]-tr;
       x[j+1]=x[i+1]-ti;
       x[i]=x[i]+tr;
       x[i+1]=x[i+1]+ti;
       i+=istep;
     } while ( i < nn );
     wtemp=wr;
     wr=wr*wpr-wi*wpi+wr;
     wi=wi*wpr+wtemp*wpi+wi;
     m+=2;
   } while ( m < mmax );
   mmax=istep;   
  }
}


void loadnorm(void)
{
  double a,b;
  unsigned char lcha;
  
  printf("Doing interval spectrum of %s\n",specinputname);
  infile=fopen(specinputname,"rt");
  
  do
  {
    fscanf(infile,"%c",&lcha);
  } while (15 < (int)lcha);
  
  
  i=0;
  do
  {
    fscanf(infile,"%d,%lf,%lf,",&id,&a,&b);
    xleft[i]=a; xright[i]=b;
    /*
    if(i==0)
    {
      printf("first line %6.8lf %6.8lf\n",a,b);
    }
    */
    if(id==0)
    {
      ispec0=i;
      /* printf("Spectrum zero spike at %d  %8.3lf %8.3lf\n",ispec0,xleft[i],xright[i]); */
    }
    
    i++;
  } while(i<4096);
  
  fclose(infile);
  
  xleft[ispec0]  = 0.25*( xleft[ispec0-2] +  xleft[ispec0-1] +  xleft[ispec0+1] +  xleft[ispec0+2]);
  xright[ispec0] = 0.25*(xright[ispec0-2] + xright[ispec0-1] + xright[ispec0+1] + xright[ispec0+2]);
  
  /* printf("Spectrum zero spike reduced to  %8.3lf %8.3lf\n",xleft[ispec0],xright[ispec0]); */
  
  
  
}



void load_fft_array(double* inarray)
{
  int icount,icd;
  icount=0; icd=1;
  x[0]=0.0;
  do
  {
    x[icd]=inarray[icount];
    icd++;
    x[icd]=0.0;
    icd++;
    icount++;
  } while (icount<npoints);
}



void generate_apodise_weights(void)
{
  int iwf,iwb;
  double weight_now,wscale,xplace;
  FILE* repfile;
  iwf=0; iwb=4095; wscale=0.0;
  
    do
    {
      xplace=(double)iwf;
      xplace=pi2*xplace/4095.0;
      weight_now= 0.35875-0.48829*cos(xplace)+0.14128*cos(2.0*xplace)-0.01168*cos(3.0*xplace);
      weight[iwf]=weight_now;
      weight[iwb]=weight_now;
      wscale+=weight_now;
      iwf++;
      iwb--;
    } while (iwf<iwb);
    
    wscale=wscale/((double)(iwf-1));
    
    iwf=0;
    do
    {
      weight[iwf]=weight[iwf]/wscale;
      iwf++;
    } while (iwf<4096);
  
}

void save_ampspectrum(double* onearray)
{
  int icount,idc;
  double p1,p2,specscale;
  specscale=1.0/4096.0;
  
  icount=0; idc=1;
  do
  {
    p1=x[idc];
    idc++;
    p2=x[idc];
    idc++;
    p1=p1*p1+p2*p2;
    
    if(p1>0.0) p1=sqrt(p1);
    onearray[icount]=specscale*p1;
    icount++;
    
  } while (icount<nhalf);
  
}


void apodise(void)
{
  int iap;
  iap=0;
  do
  {
    xleft[iap]=weight[iap]*xleft[iap];
    xright[iap]=weight[iap]*xright[iap];
    iap++;
  } while (iap<4096);
}


void save_outputspectra(void)
{
  int q;
  double f,f0;
  
  sprintf(specfilename,"%s/intervalspectrum.csv",outdirname);
  f0=1.0/4096.0;
  specfile=fopen(specfilename,"wt");
  
  fprintf(specfile," \"interval\", \"left\", \"right\",\n");
  
  q=nhalf-1;
  do
  {
    f=f0*(double)q;
    fprintf(specfile,"%8.4lf,  %7.3lf,  %7.3lf,\n",1.0/f,pout_left[q],pout_right[q]);
    q--;
  } while (q>1);
  
  fclose(specfile);
}


void report_histograms(void)
{
  /* This procedure reports the histograms collected */
  
  
  int aleft,aright,i32;
  int ih,isavelimit,ib;
  double rangescale;
  printf("Saving results\n");
  
  ih=0; isavelimit=65536; rangescale=1.0/32768.0;
  
  ib=1;
  
  

  sprintf(outfilename,"%s/left_samplestats",outdirname);
  outfile=fopen(outfilename,"wt");
  do
  {
    fprintf(outfile,"%6d, %8d,\n",ib*(ih-izero),left_hist[ih]);
    ih++;
  } while (ih<isavelimit);
  fclose(outfile);
  
  /* ih=izero/2; */
  ih=0;
  
  sprintf(outfilename,"%s/right_samplestats",outdirname);
  outfile=fopen(outfilename,"wt");
  do
  {
    fprintf(outfile,"%6d, %8d,\n",ib*(ih-izero),right_hist[ih]);
    ih++;
  } while (ih<isavelimit);
  fclose(outfile);
  
  sprintf(outfilename,"%s/normstats.csv",outdirname);
  sprintf(specinputname,"%s",outfilename);
  
  
  
  outfile=fopen(outfilename,"wt");
  fprintf(outfile," \"sval\", \"left\", \"right\",\n");
  
  
  if(bits_per_sample==16)
  {
    ih=izero-2048; isavelimit=izero+2048;
    
    do
    {
      fprintf(outfile,"%6d, %6.4lf, %6.4lf,\n",ih-izero,hscale*(double)left_hist[ih],hscale*(double)right_hist[ih]  );
      ih++;
    } while (ih<isavelimit);
  }
  
  
  
  fclose(outfile);
  
  ih=0; isavelimit=itop-1;

  sprintf(outfilename,"%s/32blocked_samplestats.csv",outdirname);
  outfile=fopen(outfilename,"wt");
  fprintf(outfile," \"sval\", \"left\", \"right\",\n");
  do
  {
    
    i32=0; aleft=0; aright=0;
    do
    {
      
      aright+=right_hist[ih];
      aleft+=left_hist[ih];
      ih++;
      i32++;
    } while (i32<32);
    
    
    fprintf(outfile,"%9.6lf, %7.3lf, %7.3lf,\n",rangescale*(double)(ih-izero-16),hscale*((double)aleft)/32.0,hscale*((double)aright)/32.0);
    
    
  } while (ih<izero);
  
  /* now do center zero value */
  
  
  fprintf(outfile,"%9.6lf, %7.3lf, %7.3lf,\n",rangescale*(double)(ih-izero),hscale*(double)left_hist[ih],hscale*(double)right_hist[ih]);
  ih++;
  
  
  do
  {
    
    i32=0; aleft=0; aright=0;
    do
    {
      
      aright+=right_hist[ih];
      aleft+=left_hist[ih];
      ih++;
      i32++;
    } while (i32<32);
    
    
    fprintf(outfile,"%9.6lf, %7.3lf, %7.3lf,\n",rangescale*(double)(ih-izero-17),hscale*((double)aleft)/32.0,hscale*((double)aright)/32.0);
    
    
  } while (ih<itop);
  
  fclose(outfile);

}






void process_results(void)
{
  int ih,icy;
  double aleft,aright,blackleft,blackright;
  
  printf("Process results\n");
  
  bscale=(double)nsamples_per_channel;
  
  printf(" %d samples per channel in track\n",(int)bscale);
  
  hscale = (double)itop;
  hscale = hscale/bscale;
  printf(" %6.4lf scaling\n",hscale);
  
  ih=izero-5; aleft=0.0; aright=0.0; icy=0;
  do
  {
    aleft  += (double)left_hist[ih];
    aright += (double)right_hist[ih];
    icy++;
    ih++;
  } while (ih<izero);
  ih++;
  
  do
  {
    aleft  += (double)left_hist[ih];
    aright += (double)right_hist[ih];
    
    icy++;
    ih++;
  } while (ih <= (izero+5));
  
  aleft = aleft/(double)icy; aright = aright/(double)icy;
  
  printf("Near zero ave sample count levels = %6.4lf %6.4lf\n",hscale*aleft,hscale*aright);
  
  blackleft=hscale*((double)left_hist[izero]-aleft);
  blackright=hscale*((double)right_hist[izero]-aright);
  
  printf("Normalised digital black counts approx L= %6.1lf  R= %6.1lf\n",blackleft,blackright);
  
  blackleft=((double)left_hist[izero]-aleft)/(double)sample_rate;
  blackright=((double)right_hist[izero]-aright)/(double)sample_rate;
  
  printf("Corresponds to L= %6.2lf  R= %6.2lf seconds of digital black silence.\n",blackleft,blackright);
  
  printf(" DC offsets L= %5.2lf  R= %5.2lf sample value\n",((double)dco_left)/bscale,((double)dco_right)/bscale);
  
  
  
  
}



void process_chunk(void)
{
  int ii,iok,iz,ispc;
  
  
  ii=0; 
  
 /* printf("process 16 on %d samples\n",ispc); */
  
   do
   {
      iok=1;
      iz=izero + (int)dbuffer[ii];
      
      dco_left+=(int)dbuffer[ii];
      
      if(iz<0)
      {
        iok=0;
        printf("left under zero\n");
      }
      if(iz>=itop)
      {
        iok=0;
        printf("left over top\n");
      }
      if(iok==1)
      {
        left_hist[iz] +=1;
      }
      
      ii++;
      
     iok=1;
      iz=izero + (int)dbuffer[ii];
      
      dco_right+=(int)dbuffer[ii];
      
      if(iz<0)
      {
        iok=0;
        printf("right under zero\n");
      }
      if(iz>=itop)
      {
        iok=0;
        printf("right over top\n");
      }
      if(iok==1)
      {
        right_hist[iz] +=1;
      } 
      ii++;
      
      nsamples_per_channel++;
      
   } while (ii<chunksize);
  
  
  printf(" *** done %d samples per channel so far\n\n",nsamples_per_channel);
  
  
}




void remove_tempfile(void)
{
  sprintf(command,"rm -f %s",tempfilename);
  
  /* printf("remove tempfile using %s\n",command); */
  system(command);
  
}



void parse_trackinfo(void)
{
  int mp,fp,dum,tlc;
  int minstart;
  double secstart;
  int lok;
  char trackline[256];
  float fdum,sp;
  char tfchar;
  printf("Parsing track details\n\n\n");
  
  sprintf(trackfilename,"%s/tracks.txt",tempdirname);
  printf("%s\n",trackfilename);
  
  tracklistfile=fopen(trackfilename,"rt");
  
  printf("File header\n\n");
  
  do
  {
    fscanf(tracklistfile,"%c",&tfchar);
    printf("%c",tfchar);
    
    if(tfchar=='U')
    {
      printf("\n\n  *** Disc read error! *** \n\n");
      discreaderror=1;
      
      printf("  Please check that you have specified the correct\n  drive in the Settings file and that you have a CD in the drive.\n");
      printf("  For more info, check the content of %s\n",tempfilename);
      printf("\n\n  ***  Exit  ***\n");
      exit(0);
      
      
    }
    
  } while (tfchar!='=');
  
  do
  {
    fscanf(tracklistfile,"%c",&tfchar);
    printf("%c",tfchar);
  } while (tfchar=='=');
  
  printf("Now track data to parse\n\n");
  
  /* fscanf(tracklistfile,"%c",&tfchar); */
  
    /* read a line */
    
  tn=0; lok=1;
  do
  {
    
  tlc=0;
  do
  {
    fscanf(tracklistfile,"%c",&tfchar);  
    if( 14 < (int)tfchar)
    {
      trackline[tlc]=tfchar;
      tlc++;
    }
    else
    {
      trackline[tlc]=(char)0;
      tlc=(-99);
    }
    if(tlc>80)
    {
      tlc=(-99);
    }
  } while (tlc>0);
  /* printf(" %s\n",trackline); */
  
  /* parse values */
  
  if (trackline[0]==(char)' ')
  {
    tn++;
  
  sscanf(trackline," %d. %d [%d:%lf] %d [%d:%f",&dum,&dum,&minstart,&secstart,&fp,&mp,&sp);
  
  startframe[tn]=fp; mins[tn]=mp; secs[tn]=(double)sp;
  
  minslong[tn]=minstart;  secslong[tn]=secstart;
  
  tracklength_blocks[tn]= minstart;
  
  tail[tn]= (int)(44100.0*4.0*secstart);
  
  /* printf("Track %d length %02d:%5.2lf = %d full 5-sec blocks plus %d tail\n",tn,minstart,secstart,tracklength_blocks[tn],tail[tn]); */
  
  /* printf("starts at %d frame %d mins %6.2lf secs\n",startframe[tn],mins[tn],secs[tn]); */
  
  }
  else
  {
    lok=0;
    
    sscanf(trackline,"TOTAL %d [%d:%f",&fp,&mp,&sp);
    startframe[0]=fp; mins[0]=mp; secs[0]=(double)sp;
    
    startframe[tn+1]=fp; mins[tn+1]=mp; secs[tn+1]=(double)sp;
    
    printf("Track list parsed\n");
  }
  
  
  } while (lok==1);
  
  numberoftracks=tn;
  
  
  fclose(tracklistfile);
  
  printf("%d tracks found on CD\n",numberoftracks);
  tn=1;
  do
  {
    /* printf("Track %d starts at %7d frame %d mins %6.2lf secs",tn,startframe[tn],mins[tn],secs[tn]); */
    printf(" Track %d length: %2d:%5.2lf  = %3d blocks plus %6d tail (approx)\n",tn,minslong[tn],secslong[tn],tracklength_blocks[tn],tail[tn]);
    
    
    tn++;
  } while (tn<=numberoftracks);
  
  printf("Disc end at %7d frame %02d mins %6.2lf secs\n",startframe[0],mins[0],secs[0]);
}



void read_settings_file(void)
{
  
  /* This proceedure reads the 'settings' file. */
  
  FILE *setfile; 
  unsigned char setfilename[512];
  sprintf(setfilename,"%s/Settings",appdirname);
  printf("Reading settings from %s\n\n",setfilename);
  setfile=fopen(setfilename,"rt"); 
  
  
  fscanf(setfile,"%s",tempdirname);
  printf("read tempdir line %s\n",tempdirname);
  fscanf(setfile,"%s",drive);
  printf("drive is %s\n",drive);
  
  fclose(setfile);
  
  sprintf(resdirname,"%s/Results",appdirname);
  printf("Results directory %s\n",resdirname);
  
  if(tempdirname[0]=='*')
  {
    sprintf(tempfilename,"%s/tempfile",resdirname);
    sprintf(tempdirname,"%s",resdirname);
  }
  else
  {
    sprintf(tempfilename,"%s/cdhctempfile",tempdirname);
  }
  
  
  
  printf("Temp dir will be %s\n",tempdirname);
  printf("Tempfile will be %s\n",tempfilename);
  
}






